module Biju
  module AT
    # Message Equipement Failure
    class CmeError < Error
      ERRORS = {
        0 => 'Phone failure',
        1 => 'No connection to phone',
        2 => 'Phone adapter link reserved',
        3 => 'Operation not allowed',
        4 => 'Operation not supported',
        5 => 'PH_SIM PIN required',
        6 => 'PH_FSIM PIN required',
        7 => 'PH_FSIM PUK required',
        10 => 'SIM not inserted',
        11 => 'SIM PIN required',
        12 => 'SIM PUK required',
        13 => 'SIM failure',
        14 => 'SIM busy',
        15 => 'SIM wrong',
        16 => 'Incorrect password',
        17 => 'SIM PIN2 required',
        18 => 'SIM PUK2 required',
        20 => 'Memory full',
        21 => 'Invalid index',
        22 => 'Not found',
        23 => 'Memory failure',
        24 => 'Text string too long',
        25 => 'Invalid characters in text string',
        26 => 'Dial string too long',
        27 => 'Invalid characters in dial string',
        30 => 'No network service',
        31 => 'Network timeout',
        32 => 'Network not allowed, emergency calls only',
        40 => 'Network personalization PIN required',
        41 => 'Network personalization PUK required',
        42 => 'Network subset personalization PIN required',
        43 => 'Network subset personalization PUK required',
        44 => 'Service provider personalization PIN required',
        45 => 'Service provider personalization PUK required',
        46 => 'Corporate personalization PIN required',
        47 => 'Corporate personalization PUK required',
        48 => 'PH-SIM PUK required',
        100 => 'Unknown error',
        103 => 'Illegal MS',
        106 => 'Illegal ME',
        107 => 'GPRS services not allowed',
        111 => 'PLMN not allowed',
        112 => 'Location area not allowed',
        113 => 'Roaming not allowed in this location area',
        126 => 'Operation temporary not allowed',
        132 => 'Service operation not supported',
        133 => 'Requested service option not subscribed',
        134 => 'Service option temporary out of order',
        148 => 'Unspecified GPRS error',
        149 => 'PDP authentication failure',
        150 => 'Invalid mobile class',
        256 => 'Operation temporarily not allowed',
        257 => 'Call barred',
        258 => 'Phone is busy',
        259 => 'User abort',
        260 => 'Invalid dial string',
        261 => 'SS not executed',
        262 => 'SIM Blocked',
        263 => 'Invalid block',
        772 => 'SIM powered down',
      }

      def initialize(id)
        super(id, 100)
      end
    end
  end
end
